/*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
 
#ifndef _OVERLAY_H
#define _OVERLAY_H


#define NAME_SIZE   256


typedef struct _OVERLAYSCHEMERECORD
{
      char    chSchemeName[NAME_SIZE];
      char    chSchemeRecord[NAME_SIZE];
      /* The format of chSchemeRecord is: "HU:%d SA:%d BR:%d CO:%d" */
} OVERLAYSCHEMERECORD, *LPOVERLAYSCHEMERECORD;

/*****=* Added for RejectOverlaySupport *=********/
/* DRAM type & Valid mode ID */
/* System Memory CLK */
#define SDR_100     1
#define SDR_133     2
#define DDR_200     3
#define DDR_266     4
#define DDR_333     5
#define DDR_400     6

/* ActiveDevice ID*/
#define	VIA_DEVICE_CRT1		0x01
#define	VIA_DEVICE_LCD		0x02
#define	VIA_DEVICE_DFP		0x08
#define	VIA_DEVICE_CRT2		0x10

#define Video_Bpp           2

/*MemEfficiency x 1000*/
/*Because Linux doesn't allow floating point in kernel*/
#define SINGLE             560/*0.56x1000*/           
#define SAMM100            600/*0.60x1000*/
#define SAMM133            460/*0.46x1000*/

#define SINGLE_3205_100    410/*0.41x1000*/
#define SINGLE_3205_133    700/*0.70x1000*/           
#define SINGLE_3205B_133   458/*0.458x1000*/ /*0.67*/        
#define SAMM100_3205       450/*0.45x1000*/
#define SAMM133_3205       510/*0.51x1000*/
#define SAMM133_3205B      520/*0.52x1000*/ /*0.64*/
#define SAMM166_3205       450/*0.45*/
#define SAMM166_3205B      450/*0.45*/ /*056*/
#define SAMM200_3205B      540/*0.54*/ /*057*/

#define SINGLE_3123C0      570/*0.57*/
#define SAMM100_3123C0     670/*0.67*/
#define SAMM133_3123C0     590/*0.59*/

typedef struct 
{
    int Width;
    int Height;
    int Refresh;
    int DClk;
} DCLK_TABLE, * LPDCLK_TABLE;

typedef struct 
{       
    unsigned long     Width;
    unsigned long     Height;   
    unsigned long     DClk;
}TV_DCLK_TABLE, * LPTV_DCLK_TABLE;
/******************End of RejectOverlaySupport **************************/

Bool RejectOverlay(PVIDDATA pVidData);
Bool RejectOverlay_3123C0(PVIDDATA pVidData);
Bool RejectOverlay_3205(PVIDDATA pVidData);
Bool RejectOverlay_3204(PVIDDATA pVidData);


#ifdef XFree86Server

#define     INDEX_OVERLAY_HUE           0
#define     INDEX_OVERLAY_SATURATION    1
#define     INDEX_OVERLAY_BRIGHTNESS    2
#define     INDEX_OVERLAY_CONTRAST      3

#define     DEFAULT_SYS_HUE             0
#define     DEFAULT_SYS_SATURATION      10000
#define     DEFAULT_SYS_BRIGHTNESS      5000
#define     DEFAULT_SYS_CONTRAST        10000

#define     DEFAULT_UI_HUE              128
#define     DEFAULT_UI_SATURATION       128
#define     DEFAULT_UI_BRIGHTNESS       128
#define     DEFAULT_UI_CONTRAST         128

#define     MIN_UI_HUE                  0
#define     MIN_UI_SATURATION           0
#define     MIN_UI_BRIGHTNESS           0
#define     MIN_UI_CONTRAST             0

#define     MAX_UI_HUE                  255
#define     MAX_UI_SATURATION           255
#define     MAX_UI_BRIGHTNESS           255
#define     MAX_UI_CONTRAST             255

typedef struct _S3OVERLAYPROPERTY
{
    int sys_range;
    int sys_min;
    int sys_max;
    int ui_range;
    int ui_min;
    int ui_max;
    int default_sys_value;
    int default_ui_value;    
}
S3OVRLAYPROPERTY;

void SetVideoColor(PVIDDATA pVidData, long Hue, long Saturation, long Brightness, long Contrast);
unsigned long vfLoadColorSetting(PVIDDATA pVidData, viaPortPrivPtr pPriv);

#endif /* ifndef VMIONLY */

#endif /* _OVERLAY_H */
