/*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef _VIA_DVI_H_
#define _VIA_DVI_H_ 1

#define CONNECT_HDMI    0x1
#define CONNECT_DVI     0x2

typedef struct {
    CARD32 HorSize;
    CARD32 VerSize;
}CEA_TIMING_FORMAT;

void VIADVISetMode(VIABIOSInfoPtr pBIOSInfo);
void VIASetDVIOutputPath(VIABIOSInfoPtr pBIOSInfo, int set_iga, int output_interface);
Bool VIATMDSIdentify(VIABIOSInfoPtr pBIOSInfo);
Bool VIASenseDVI(VIABIOSInfoPtr pBIOSInfo);
int VIAQueryDVIEDIDType(VIABIOSInfoPtr pBIOSInfo);
CARD8 VIAGetPanelSizeFromEDID(VIABIOSInfoPtr pBIOSInfo);
unsigned char VIAGetPanelSizeFromDDCv1(VIABIOSInfoPtr pBIOSInfo);
unsigned char VIAGetPanelSizeFromDDCv2(VIABIOSInfoPtr pBIOSInfo);
unsigned char VIAGetPanelInfo(VIABIOSInfoPtr pBIOSInfo);
Bool VIASetDFPMode(VIABIOSInfoPtr pBIOSInfo);
void VIAEnableDFP(VIABIOSInfoPtr pBIOSInfo);
void VIADisableDFP(VIABIOSInfoPtr pBIOSInfo);
void VideoSetMode(VIABIOSInfoPtr pBIOSInfo, int set_iga);
unsigned char VIAGetDeviceDetectDVI(VIABIOSInfoPtr pBIOSInfo);
void VIATMDSRegInit(VIABIOSInfoPtr pBIOSInfo);
void VIADVIPatchSkew_DVP0(VIABIOSInfoPtr pBIOSInfo);
void VIADVIPatchSkew_DVP1(VIABIOSInfoPtr pBIOSInfo);
void VIADVIPatchSkew_DFPLOW(VIABIOSInfoPtr pBIOSInfo);

#endif  /* _VIA_DVI_H_ */

